
{******************************************************
*     Dimarker's Software 1991.  Forms for TVision    *
******************************************************}

{$F+,N+,E+,O+,S-,X+,D-,L-}

unit Fields;

interface

uses Objects, Views, Dialogs, Drivers;

type

 ESet = set of char;

 PLString = ^LString;
 LString  = object(TInputLine)
   Id      : word;
   Idc     : char;
   EditSet : ESet;
   constructor Init(var Bounds: TRect; AMaxLen: Integer);
   constructor Load(var S: TStream);
   procedure   Store(var S:TStream);
   procedure HandleEvent(var Event: TEvent); virtual;
 end;

 PNullString = ^NullString;
 NullString  = object(LString)
   procedure SetData(var Rec); virtual;
   procedure GetData(var Rec); virtual;
 end;

 PLByte     = ^LByte;
 LByte      = object(LString)
   constructor Init(var Bounds: TRect);
   function DataSize: word; virtual;
   procedure SetData(var Rec); virtual;
   procedure GetData(var Rec); virtual;
   function  Valid(Command: word): boolean; virtual;
 end;

 PLWord  = ^LWord;
 LWord   = object(LString)
   constructor Init(var Bounds: TRect);
   function DataSize: word; virtual;
   procedure SetData(var Rec); virtual;
   procedure GetData(var Rec); virtual;
   function  Valid(Command: word): boolean; virtual;
 end;

 PLShort  = ^LShort;
 LShort   = object(LString)
   constructor Init(var Bounds: TRect);
   function DataSize: word; virtual;
   procedure SetData(var Rec); virtual;
   procedure GetData(var Rec); virtual;
   function  Valid(Command: word): boolean; virtual;
 end;

 PLInteger  = ^LInteger;
 LInteger   = object(LString)
   constructor Init(var Bounds: TRect);
   function DataSize: word; virtual;
   procedure SetData(var Rec); virtual;
   procedure GetData(var Rec); virtual;
   function  Valid(Command: word): boolean; virtual;
 end;

 PLLongint  = ^LLongint;
 LLongint   = object(LString)
   constructor Init(var Bounds: TRect);
   function DataSize: word; virtual;
   procedure SetData(var Rec); virtual;
   procedure GetData(var Rec); virtual;
   function  Valid(Command: word): boolean; virtual;
 end;

 PLSingle  = ^LSingle;
 LSingle   = object(LString)
   Len, Decm : byte;
   constructor Init(var Bounds: TRect; RLen, RDec : byte);
   constructor Load(var S: TStream);
   procedure Store(var S: TStream);
   function DataSize: word; virtual;
   procedure SetData(var Rec); virtual;
   procedure GetData(var Rec); virtual;
   function  Valid(Command: word): boolean; virtual;
 end;

 PLReal  = ^LReal;
 LReal   = object(LString)
   Len, Decm : byte;
   constructor Init(var Bounds: TRect; RLen, RDec : byte);
   constructor Load(var S: TStream);
   procedure Store(var S: TStream);
   function DataSize: word; virtual;
   procedure SetData(var Rec); virtual;
   procedure GetData(var Rec); virtual;
   function  Valid(Command: word): boolean; virtual;
 end;

 PLDouble  = ^LDouble;
 LDouble   = object(LString)
   Len, Decm : byte;
   constructor Init(var Bounds: TRect; RLen, RDec : byte);
   constructor Load(var S: TStream);
   procedure Store(var S: TStream);
   function DataSize: word; virtual;
   procedure SetData(var Rec); virtual;
   procedure GetData(var Rec); virtual;
   function  Valid(Command: word): boolean; virtual;
 end;

 PLExtended  = ^LExtended;
 LExtended   = object(LString)
   Len, Decm : byte;
   constructor Init(var Bounds: TRect; RLen, RDec : byte);
   constructor Load(var S: TStream);
   procedure Store(var S: TStream);
   function DataSize: word; virtual;
   procedure SetData(var Rec); virtual;
   procedure GetData(var Rec); virtual;
   function  Valid(Command: word): boolean; virtual;
 end;

 PLComplex  = ^LComplex;
 LComplex   = object(LString)
   Len, Decm : byte;
   constructor Init(var Bounds: TRect; RLen, RDec : byte);
   constructor Load(var S: TStream);
   procedure Store(var S: TStream);
   function DataSize: word; virtual;
   procedure SetData(var Rec); virtual;
   procedure GetData(var Rec); virtual;
   function  Valid(Command: word): boolean; virtual;
 end;

 PLDate  = ^LDate;
 LDate   = object(LString)
   Pict  : string[20];
   constructor Init(var Bounds: TRect; APicture : string);
   constructor Load(var S: TStream);
   procedure Store(var S: TStream);
   function  DataSize: word; virtual;
   procedure SetData(var Rec); virtual;
   procedure SetState(AState: word; Enable: boolean); virtual;
   procedure HandleEvent(var Event: TEvent); virtual;
   procedure GetData(var Rec); virtual;
   function  Valid(Command: word): boolean; virtual;
 end;

 PLTime  = ^LTime;
 LTime   = object(LDate)
   constructor Init(var Bounds: TRect; APicture : string);
   constructor Load(var S: TStream);
   procedure Store(var S: TStream);
   procedure SetData(var Rec); virtual;
   procedure GetData(var Rec); virtual;
   function  Valid(Command: word): boolean; virtual;
 end;

 PLChar  = ^LChar;
 LChar   = object(LString)
   constructor Init(var Bounds: TRect);
   function DataSize: word; virtual;
   procedure SetData(var Rec); virtual;
   procedure GetData(var Rec); virtual;
 end;

 PLBoolean  = ^LBoolean;
 LBoolean   = object(LString)
   constructor Init(var Bounds: TRect);
   function DataSize: word; virtual;
   procedure SetData(var Rec); virtual;
   procedure GetData(var Rec); virtual;
   function  Valid(Command: word): boolean; virtual;
 end;

const
 RLString: TStreamRec = (
   ObjType: 1001;
   VmtLink: Ofs(TypeOf(LString)^);
   Load   : @LString.Load;
   Store  : @LString.Store);

{ RLByte: TStreamRec = (
   ObjType: 1002;
   VmtLink: Ofs(TypeOf(LByte)^);
   Load   : @LByte.Load;
   Store  : @LByte.Store); }

 RLWord: TStreamRec = (
   ObjType: 1003;
   VmtLink: Ofs(TypeOf(LWord)^);
   Load   : @LWord.Load;
   Store  : @LWord.Store);

{ RLShort: TStreamRec = (
   ObjType: 1004;
   VmtLink: Ofs(TypeOf(LShort)^);
   Load   : @LShort.Load;
   Store  : @LShort.Store); }

 RLInteger: TStreamRec = (
   ObjType: 1005;
   VmtLink: Ofs(TypeOf(LInteger)^);
   Load   : @LInteger.Load;
   Store  : @LInteger.Store);

 RLLongint: TStreamRec = (
   ObjType: 1006;
   VmtLink: Ofs(TypeOf(LLongint)^);
   Load   : @LLongint.Load;
   Store  : @LLongint.Store);

{ RLSingle: TStreamRec = (
   ObjType: 1007;
   VmtLink: Ofs(TypeOf(LSingle)^);
   Load   : @LSingle.Load;
   Store  : @LSingle.Store); }

{ RLReal: TStreamRec = (
   ObjType: 1008;
   VmtLink: Ofs(TypeOf(LReal)^);
   Load   : @LReal.Load;
   Store  : @LReal.Store); }

 RLDouble: TStreamRec = (
   ObjType: 1009;
   VmtLink: Ofs(TypeOf(LDouble)^);
   Load   : @LDouble.Load;
   Store  : @LDouble.Store);

{ RLExtended: TStreamRec = (
   ObjType: 1010;
   VmtLink: Ofs(TypeOf(LExtended)^);
   Load   : @LExtended.Load;
   Store  : @LExtended.Store); }

{ RLComplex: TStreamRec = (
   ObjType: 1011;
   VmtLink: Ofs(TypeOf(LComplex)^);
   Load   : @LComplex.Load;
   Store  : @LComplex.Store); }

 RLDate: TStreamRec = (
   ObjType: 1012;
   VmtLink: Ofs(TypeOf(LDate)^);
   Load   : @LDate.Load;
   Store  : @LDate.Store);

{ RLChar: TStreamRec = (
   ObjType: 1013;
   VmtLink: Ofs(TypeOf(LChar)^);
   Load   : @LChar.Load;
   Store  : @LChar.Store); }

{ RLBoolean: TStreamRec = (
   ObjType: 1014;
   VmtLink: Ofs(TypeOf(LBoolean)^);
   Load   : @LBoolean.Load;
   Store  : @LBoolean.Store); }

 RLTime: TStreamRec = (
   ObjType: 1016;
   VmtLink: Ofs(TypeOf(LTime)^);
   Load   : @LTime.Load;
   Store  : @LTime.Store);


 procedure RegisterFields;

implementation uses TBDTM, Strings;

{ LString }

constructor LString.Init(var Bounds: TRect; AMaxLen: Integer);
 begin
  inherited Init(Bounds, AMaxLen);
  DragMode:=dmDragMove + dmLimitAll + dmDragGrow;
  EditSet:=[#0..#255];
  Idc:='S';
 end;

constructor LString.Load(var S: TStream);
 begin
  inherited Load(S);
  S.Read(Id, SizeOf(Id));
  S.Read(Idc, SizeOf(Idc));
  S.Read(EditSet, SizeOf(EditSet));
 end;

procedure LString.Store(var S: TStream);
 begin
  inherited Store(S);
  S.Write(Id, SizeOf(Id));
  S.Write(Idc, SizeOf(Idc));
  S.Write(EditSet, SizeOf(EditSet));
 end;

procedure LString.HandleEvent(var Event: TEvent);
 begin
  if (Event.What = evKeyDown) and (Event.CharCode <> #0)
   then if not (Event.CharCode in EditSet) then
    begin
     ClearEvent(Event);
    end;
  inherited HandleEvent(Event);
 end;


{ NullString }

procedure NullString.SetData(var Rec);
 var w: word;
 begin
  w:=StrLen(PChar(Rec));
  if w >= DataSize then w:=DataSize - 1;
  Move(PChar(Rec)[0], Data^[1], w);
  Data^[0]:=char(w);
  DrawView;
 end;

procedure NullString.GetData(var Rec);
 begin
  Move(Data^[1], PChar(Rec)[0], DataSize - 1);
  PChar(Rec)[integer(DataSize)]:=#0;
 end;


{ LByte }

constructor LByte.Init(var Bounds: TRect);
 var D : byte;
 begin
  Bounds.B.X:=Bounds.A.X + 5;
  inherited Init(Bounds, 3);
  DragMode:=dmDragMove + dmLimitAll;
  EditSet:=[#0..#31,#36,#48..#57];
  Idc:='B';
  D:=0;
  SetData(D);
 end;

function LByte.DataSize: word;
 begin
  DataSize:=SizeOf(byte);
 end;

procedure LByte.SetData(var Rec);
 var S : string;
 begin
  Str(byte(Rec), S);
  Data^:=S;
  DrawView;
 end;

procedure LByte.GetData(var Rec);
 var D,i : integer;
 begin
  Val(Data^, D, i);
  if (i <> 0) and (D < 0) and (D > 255) then byte(Rec):=0
   else byte(Rec):=byte(D);
 end;

function LByte.Valid(Command: word): boolean;
 var
  i : integer;
  D : integer;
 begin
  if Command = cmCancel then
   begin
    Valid:=True;
    Exit;
   end else
    begin
     Val(Data^, D, i);
     if (i <> 0) or (D < 0) or (D > 255) then Valid:=False
      else Valid:=True;
    end;
 end;


{ LWord }

constructor LWord.Init(var Bounds: TRect);
 var D : word;
 begin
  Bounds.B.X:=Bounds.A.X + 7;
  inherited Init(Bounds, 5);
  DragMode:=dmDragMove + dmLimitAll;
  EditSet:=[#0..#31,#36,#48..#57];
  Idc:='W';
  D:=0;
  SetData(D);
 end;

function LWord.DataSize: word;
 begin
  DataSize:=SizeOf(word);
 end;

procedure LWord.SetData(var Rec);
 var S : String;
 begin
  Str(word(Rec), S);
  Data^:=S;
  DrawView;
 end;

procedure LWord.GetData(var Rec);
 var i : integer;
 begin
  Val(Data^, word(Rec), i);
  if i <> 0 then word(Rec):=0;
 end;

function LWord.Valid(Command: word): boolean;
 var
  i : integer;
  D : word;
 begin
  if Command = cmCancel then
   begin
    Valid:=True;
    Exit;
   end else
    begin
     Val(Data^, D, i);
     if i <> 0 then Valid:=False
      else Valid:=True;
    end;
 end;


{ LShort }

constructor LShort.Init(var Bounds: TRect);
 var D : integer;
 begin
  Bounds.B.X:=Bounds.A.X + 6;
  inherited Init(Bounds, 4);
  DragMode:=dmDragMove + dmLimitAll;
  EditSet:=[#0..#31,'-','0'..'9'];
  Idc:='H';
  D:=0;
  SetData(D);
 end;

function LShort.DataSize: word;
 begin
  DataSize:=SizeOf(shortint);
 end;

procedure LShort.SetData(var Rec);
 var S : string;
 begin
  Str(shortint(Rec), S);
  Data^:=S;
  DrawView;
 end;

procedure LShort.GetData(var Rec);
 var i : integer;
 begin
  Val(Data^, shortint(Rec), i);
  if i <> 0 then shortint(Rec):=0;
 end;

function LShort.Valid(Command: word): boolean;
 var i, D : integer;
 begin
  if Command = cmCancel then
   begin
    Valid:=True;
    Exit;
   end else
    begin
     Val(Data^, D, i);
     if (i <> 0) or (D > 128) or (D < -127) then Valid:=False
      else Valid:=True;
    end;
 end;


{ LInteger }

constructor LInteger.Init(var Bounds: TRect);
 var D : integer;
 begin
  Bounds.B.X:=Bounds.A.X + 8;
  inherited Init(Bounds, 6);
  DragMode:=dmDragMove + dmLimitAll;
  EditSet:=[#0..#31,#45,#48..#57];
  Idc:='I';
  D:=0;
  SetData(D);
 end;

function LInteger.DataSize: word;
 begin
  DataSize:=SizeOf(integer);
 end;

procedure LInteger.SetData(var Rec);
 var S : string;
 begin
  Str(integer(Rec), S);
  Data^:=S;
  DrawView;
 end;

procedure LInteger.GetData(var Rec);
 var i : integer;
 begin
  Val(Data^, integer(Rec), i);
  if i <> 0 then integer(Rec):=0;
 end;

function LInteger.Valid(Command: word): boolean;
 var i, D : integer;
 begin
  if Command = cmCancel then
   begin
    Valid:=True;
    Exit;
   end else
    begin
     Val(Data^, D, i);
     if i <> 0 then Valid:=False
      else Valid:=True;
    end;
 end;


{ LLongint }

constructor LLongint.Init(var Bounds: TRect);
 var D : longint;
 begin
  Bounds.B.X:=Bounds.A.X + 13;
  inherited Init(Bounds, 11);
  DragMode:=dmDragMove + dmLimitAll;
  EditSet:=[#0..#31,#45,#48..#57];
  Idc:='G';
  D:=0;
  SetData(D);
 end;

function LLongint.DataSize: word;
 begin
  DataSize:=SizeOf(longint);
 end;

procedure LLongint.SetData(var Rec);
 var S : string;
 begin
  Str(longint(Rec), S);
  Data^:=S;
  DrawView;
 end;

procedure LLongint.GetData(var Rec);
 var i : integer;
 begin
  Val(Data^, longint(Rec), i);
  if i <> 0 then longint(Rec):=0;
 end;

function LLongInt.Valid(Command: word): boolean;
 var
  i : integer;
  D : longint;
 begin
  if Command = cmCancel then
   begin
    Valid:=True;
    Exit;
   end else
    begin
     Val(Data^, D, i);
     if i <> 0 then Valid:=False
      else Valid:=True;
    end;
 end;


{ LSingle }

constructor LSingle.Init(var Bounds: TRect; RLen, RDec : byte);
 var D : single;
 begin
  Bounds.B.X:=Bounds.A.X + RLen + 2;
  inherited Init(Bounds, RLen);
  Len:=RLen; Decm:=RDec;
  DragMode:=dmDragMove + dmLimitAll;
  EditSet:=[#0..#31,#45,#46,#48..#57];
  Idc:='N';
  D:=0;
  SetData(D);
 end;

constructor LSingle.Load(var S: TStream);
 begin
  inherited Load(S);
  S.Read(Len, SizeOf(Len));
 end;

procedure LSingle.Store(var S: TStream);
 begin
  inherited Store(S);
  S.Write(Len, SizeOf(Len));
 end;

function LSingle.DataSize: word;
 begin
  DataSize:=SizeOf(single);
 end;

procedure LSingle.SetData(var Rec);
 var
   S : string;
   i : integer;
 begin
  Str(single(Rec):1:Decm, S);
  Data^:=S;
  DrawView;
 end;

procedure LSingle.GetData(var Rec);
 var
  R : single;
  i : integer;
 begin
  Val(Data^, R, i);
  if (i = 0) and (R < 3.4e38) and (R > 1.5e-45) then Real(Rec):=R
  else real(Rec):=0;
 end;

function LSingle.Valid(Command: word): boolean;
 var
  i : integer;
  D : single;
 begin
  if Command = cmCancel then
   begin
    Valid:=True;
    Exit;
   end else
    begin
     Val(Data^, D, i);
     if i <> 0 then Valid:=False
      else Valid:=True;
     if Pos('.', Data^) > 0 then
      if (Length(Data^) - Pos('.', Data^)) > Decm then
       Valid:=False;
    end;
 end;


{ LReal }

constructor LReal.Init(var Bounds: TRect; RLen, RDec : byte);
 var D : real;
 begin
  Bounds.B.X:=Bounds.A.X + RLen + 2;
  inherited Init(Bounds, RLen);
  Len:=RLen; Decm:=RDec;
  DragMode:=dmDragMove + dmLimitAll;
  EditSet:=[#0..#31,#45,#46,#48..#57];
  Idc:='R';
  D:=0;
  SetData(D);
 end;

constructor LReal.Load(var S: TStream);
 begin
  inherited Load(S);
  S.Read(Len, SizeOf(Len));
 end;

procedure LReal.Store(var S: TStream);
 begin
  inherited Store(S);
  S.Write(Len, SizeOf(Len));
 end;

function LReal.DataSize: word;
 begin
  DataSize:=SizeOf(real);
 end;

procedure LReal.SetData(var Rec);
 var
   S : string;
   i : integer;
 begin
  Str(real(Rec):1:Decm, S);
  Data^:=S;
  DrawView;
 end;

procedure LReal.GetData(var Rec);
 var i : integer;
 begin
  Val(Data^, real(Rec), i);
  if i <> 0 then real(Rec):=0;
 end;

function LReal.Valid(Command: word): boolean;
 var
  i : integer;
  D : real;
 begin
  if Command = cmCancel then
   begin
    Valid:=True;
    Exit;
   end else
    begin
     Val(Data^, D, i);
     if i <> 0 then Valid:=False
      else Valid:=True;
     if Pos('.', Data^) > 0 then
      if (Length(Data^) - Pos('.', Data^)) > Decm then
       Valid:=False;
    end;
 end;


{ LDouble }

constructor LDouble.Init(var Bounds: TRect; RLen, RDec : byte);
 var D : double;
 begin
  Bounds.B.X:=Bounds.A.X + RLen + 2;
  inherited Init(Bounds, RLen);
  Len:=RLen; Decm:=RDec;
  DragMode:=dmDragMove + dmLimitAll;
  EditSet:=[#0..#31,#45,#46,#48..#57];
  Idc:='U';
  D:=0;
  SetData(D);
 end;

constructor LDouble.Load(var S: TStream);
 begin
  inherited Load(S);
  S.Read(Len, SizeOf(Len));
 end;

procedure LDouble.Store(var S: TStream);
 begin
  inherited Store(S);
  S.Write(Len, SizeOf(Len));
 end;

function LDouble.DataSize: word;
 begin
  DataSize:=SizeOf(double);
 end;

procedure LDouble.SetData(var Rec);
 var
   S : string;
   i : integer;
 begin
  Str(double(Rec):1:Decm, S);
  Data^:=S;
  DrawView;
 end;

procedure LDouble.GetData(var Rec);
 var
  R : Double;
  i : integer;
 begin
  Val(Data^, R, i);
  if (i = 0) then double(Rec):=R
  else double(Rec):=0;
 end;

function LDouble.Valid(Command: word): boolean;
 var
  i : integer;
  D : double;
 begin
  if Command = cmCancel then
   begin
    Valid:=True;
    Exit;
   end else
    begin
     Val(Data^, D, i);
     if i <> 0 then Valid:=False
      else Valid:=True;
     if Pos('.', Data^) > 0 then
      if (Length(Data^) - Pos('.', Data^)) > Decm then
       Valid:=False;
    end;
 end;


{ LExtended }

constructor LExtended.Init(var Bounds: TRect; RLen, RDec : byte);
 var D : extended;
 begin
  Bounds.B.X:=Bounds.A.X + RLen + 2;
  inherited Init(Bounds, RLen);
  Len:=RLen; Decm:=RDec;
  DragMode:=dmDragMove + dmLimitAll;
  EditSet:=[#0..#31,#45,#46,#48..#57];
  Idc:='E';
  D:=0;
  SetData(D);
 end;

constructor LExtended.Load(var S: TStream);
 begin
  inherited Load(S);
  S.Read(Len, SizeOf(Len));
 end;

procedure LExtended.Store(var S: TStream);
 begin
  inherited Store(S);
  S.Write(Len, SizeOf(Len));
 end;

function LExtended.DataSize: word;
 begin
  DataSize:=SizeOf(extended);
 end;

procedure LExtended.SetData(var Rec);
 var
   S : string;
   i : integer;
 begin
  Str(extended(Rec):1:Decm, S);
  Data^:=S;
  DrawView;
 end;

procedure LExtended.GetData(var Rec);
 var
  R : extended;
  i : integer;
 begin
  Val(Data^, R, i);
  if (i = 0) then extended(Rec):=R
  else extended(Rec):=0;
 end;

function LExtended.Valid(Command: word): boolean;
 var
  i : integer;
  D : Extended;
 begin
  if Command = cmCancel then
   begin
    Valid:=True;
    Exit;
   end else
    begin
     Val(Data^, D, i);
     if i <> 0 then Valid:=False
      else Valid:=True;
     if Pos('.', Data^) > 0 then
      if (Length(Data^) - Pos('.', Data^)) > Decm then
       Valid:=False;
    end;
 end;


{ LComplex }

constructor LComplex.Init(var Bounds: TRect; RLen, RDec : byte);
 var D : comp;
 begin
  Bounds.B.X:=Bounds.A.X + RLen + 2;
  inherited Init(Bounds, RLen);
  Len:=RLen; Decm:=RDec;
  DragMode:=dmDragMove + dmLimitAll;
  EditSet:=[#0..#31,#45,#46,#48..#57];
  Idc:='X';
  D:=0;
  SetData(D);
 end;

constructor LComplex.Load(var S: TStream);
 begin
  inherited Load(S);
  S.Read(Len, SizeOf(Len));
 end;

procedure LComplex.Store(var S: TStream);
 begin
  inherited Store(S);
  S.Write(Len, SizeOf(Len));
 end;

function LComplex.DataSize: word;
 begin
  DataSize:=SizeOf(comp);
 end;

procedure LComplex.SetData(var Rec);
 var
   S : string;
   i : integer;
 begin
  Str(comp(Rec):1:Decm, S);
  Data^:=S;
  DrawView;
 end;

procedure LComplex.GetData(var Rec);
 var
  R : comp;
  i : integer;
 begin
  Val(Data^, R, i);
  if (i = 0) then comp(Rec):=R
  else comp(Rec):=0;
 end;

function LComplex.Valid(Command: word): boolean;
 var
  i : integer;
  D : comp;
 begin
  if Command = cmCancel then
   begin
    Valid:=True;
    Exit;
   end else
    begin
     Val(Data^, D, i);
     if i <> 0 then Valid:=False
      else Valid:=True;
     if Pos('.', Data^) > 0 then
      if (Length(Data^) - Pos('.', Data^)) > Decm then
       Valid:=False;
    end;
 end;


{ LDate }

constructor LDate.Init(var Bounds: TRect; APicture: string);
 var D : longint;
 begin
  Bounds.B.X:=Bounds.A.X + 2 + Length(APicture);
  inherited Init(Bounds, Length(APicture));
  Pict:=Copy(APicture, 1, 20);
  DragMode:=dmDragMove + dmLimitAll;
  State:=State or sfCursorIns;
  EditSet:=[#0..#31,#48..#57];
  Idc:='D';
  D:=Today;
  SetData(D);
 end;

constructor LDate.Load(var S: TStream);
 begin
  inherited Load(S);
  S.Read(Pict, SizeOf(Pict));
 end;

procedure LDate.Store(var S: TStream);
 begin
  inherited Store(S);
  S.Write(Pict, SizeOf(Pict));
 end;

function LDate.DataSize: word;
 begin
  DataSize:=SizeOf(longint);
 end;

procedure LDate.SetData(var Rec);
 begin
  Data^:=DateToDateString(Pict, longint(Rec));
  DrawView;
 end;

procedure LDate.SetState(AState: word; Enable: boolean);
 begin
  if AState = sfCursorIns then Exit;
  inherited SetState(AState, Enable);
  if (AState = sfSelected) and (Enable = True) then
   SelectAll(False);
 end;

procedure LDate.HandleEvent(var Event: TEvent);
 var
  RS : set of char;
 begin
  RS:=['/','-','.',':'];
  if Event.What = evKeyDown then
   begin
    if Event.KeyCode = kbDel then Event.KeyCode:=kbBack;
    if Event.KeyCode = kbBack then
     if CurPos > 0 then
      begin
       if Data^[CurPos] in RS then CurPos:=CurPos - 1;
       if Data^[CurPos] in [#32,#48..#57] then
        begin
         Data^[CurPos]:=#32;
         CurPos:=CurPos - 1;
         Event.KeyCode:=kbNoKey;
         if Data^[CurPos] in RS then
          CurPos:=CurPos - 1;
         DrawView;
        end;
      end;
   case Event.KeyCode of
    kbLeft : if CurPos > 0 then
              if Data^[CurPos] in RS then
               CurPos:=CurPos - 1;
    kbRight: if CurPos < MaxLen then
              if Data^[CurPos + 2] in RS then
               CurPos:=CurPos + 1;
   end;
  end;
  if (Event.What = evKeyDown) and (Event.CharCode in [#48..#57]) then
   begin
    inherited HandleEvent(Event);
    if Data^[CurPos + 1] in RS then
     begin
      Event.What   := evKeyDown;
      Event.KeyCode:= kbRight;
      Event.InfoPtr:= @Self;
     end;
   end;
  LString.HandleEvent(Event);
 end;

procedure LDate.GetData(var Rec);
 var D : longint;
 begin
  D:=DateStringToDate(Pict, Data^);
  if D = -1 then
   longint(Rec):=DateStringToDate(Pict, '01/01/91')
  else longint(Rec):=D;
 end;

function LDate.Valid(Command: word): boolean;
 var
  i : integer;
  D : longint;
 begin
  if Command = cmCancel then
   begin
    Valid:=True;
    Exit;
   end else
    begin
     D:=DateStringToDate(Pict, Data^);
     if D = -1 then Valid:=False
      else Valid:=True;
    end;
 end;


{ LTime }

constructor LTime.Init(var Bounds: TRect; APicture: string);
 var D : longint;
 begin
  Bounds.B.X:=Bounds.A.X + 2 + Length(APicture);
  LString.Init(Bounds, Length(APicture));
  { don't use inherited here ! }
  Pict:=Copy(APicture, 1, 20);
  DragMode:=dmDragMove + dmLimitAll;
  State:=State or sfCursorIns;
  EditSet:=[#0..#31,#48..#57];
  Idc:='T';
  D:=CurrentTime;
  SetData(D);
 end;

constructor LTime.Load(var S: TStream);
 begin
  inherited Load(S);
 end;

procedure LTime.Store(var S: TStream);
 begin
  inherited Store(S);
 end;

procedure LTime.SetData(var Rec);
 begin
  Data^:=TimeToTimeString(Pict, longint(Rec));
  DrawView;
 end;

procedure LTime.GetData(var Rec);
 var D : longint;
 begin
  D:=TimeStringToTime(Pict, Data^);
  if D = -1 then
   longint(Rec):=TimeStringToTime(Pict, '01/01/91')
  else longint(Rec):=D;
 end;

function LTime.Valid(Command: word): boolean;
 var
  i : integer;
  D : longint;
 begin
  if Command = cmCancel then
   begin
    Valid:=True;
    Exit;
   end else
    begin
     D:=TimeStringToTime(Pict, Data^);
     if D = -1 then Valid:=False
      else Valid:=True;
    end;
 end;


{ LChar }

constructor LChar.Init(var Bounds: TRect);
 var D : char;
 begin
  Bounds.B.X:=Bounds.A.X + 3;
  inherited Init(Bounds, 1);
  DragMode:=dmDragMove + dmLimitAll;
  EditSet:=[#0..#255];
  Idc:='C';
  D:=#0;
  SetData(D);
 end;

function LChar.DataSize: word;
 begin
  DataSize:=SizeOf(char);
 end;

procedure LChar.SetData(var Rec);
 var i : integer;
 begin
  Data^:=char(Rec);
  DrawView;
 end;

procedure LChar.GetData(var Rec);
 var i : integer;
 begin
  if byte(Data^[0]) = 0 then char(Rec):=#0
   else char(Rec):=Data^[1];
 end;


{ LBoolean }

constructor LBoolean.Init(var Bounds: TRect);
 var D : boolean;
 begin
  Bounds.B.X:=Bounds.A.X + 3;
  inherited Init(Bounds, 1);
  DragMode:=dmDragMove + dmLimitAll;
  EditSet:=[#0..#31,'N','n','Y','y','','','',''];
  Idc:='L';
  D:=False;
  SetData(D);
 end;

function LBoolean.DataSize: word;
 begin
  DataSize:=SizeOf(boolean);
 end;

procedure LBoolean.SetData(var Rec);
 var i : integer;
 begin
  if boolean(Rec) then Data^:='Y'
   else Data^:='N';
  DrawView;
 end;

procedure LBoolean.GetData(var Rec);
 var i : integer;
 begin
  if Data^[1] in ['Y','y','',''] then boolean(Rec):=True
   else boolean(Rec):=False;
 end;

function LBoolean.Valid(Command: word): boolean;
 begin
  if Command = cmCancel then
   begin
    Valid:=True;
    Exit;
   end else
    begin
     if Data^[1] in EditSet then Valid:=True
      else Valid:=False;
    end;
 end;

procedure RegisterFields;
 begin
  RegisterType(RLString);
{  RegisterType(RLByte);     }
  RegisterType(RLWord);
{  RegisterType(RLShort);    }
  RegisterType(RLInteger);
  RegisterType(RLLongint);
{  RegisterType(RLSingle);   }
{  RegisterType(RLReal);     }
  RegisterType(RLDouble);
{  RegisterType(RLExtended); }
{  RegisterType(RLComplex);  }
  RegisterType(RLDate);
{  RegisterType(RLChar);     }
{  RegisterType(RLBoolean);  }
  RegisterType(RLTime);
 end;

end.
