{$F+,N+,E+,D-,L-}

{    Paradox Engine 3.0 楤,   
   אַ  ⠡   ,   ⥫쭮
  ᪮ ⥭/ .  ᫮   ⠡ Paradox
  ࠭  ᯥ樠쭮 ଠ,   ।⢥
  ஥ ᮢ  ⨬   ਬ ᯥ樠 㭪権
  樨 . ८ࠧ   ଠ  (..  
  ࠭  ᯮ  EXE 䠩) ந室 ⮫쪮  ⥭
    ⠡,  ⭮ -   .
   ਢ  㭪権  ᮮ⢥饣 ८ࠧ.
  XXXToKey - ८ࠧ ६   饭  ⠡ 
             PXRawPut ( TCursor.appendRaw, InsertRaw, updateRaw)
  KeyToXXX - ८ࠧ  ଠ Paradox   . 
             ८ࠧ ᫥ 樨 PXRawGet (
             TCursor.getRawRecord)

                  Dimarker's Software 1993

}

unit KeyConv; { original NUMKEYS.PAS from BTree-Filer }

interface

function IntToKey(I: integer) : integer;
  {-Convert an integer to a integerkey }

function KeyToInt(I: integer) : Integer;
  {-Convert a integerkey to an integer }

function LongToKey(L: LongInt) : longint;
  {-Convert a longint to a longintkey }

function KeyToLong(L: longint) : LongInt;
  {-Convert a longintkey to a longint }

function DoubToKey(D : Double) : Double;
  {-Convert an double to a doublekey }

function KeyToDoub(D : double) : double;
  {-Convert an doublekey to a double }

implementation

type { typedef from OBJECTS.PAS}
 LongRec = record
   Lo, Hi: Word;
 end;

procedure ReverseBytes(var V; Size : Word);
  {-Reverse the ordering of bytes from V[1] to V[Size]. Size must be >= 2.}
 inline(
  $8C/$DB/                 {mov bx,ds    ;save DS}
  $59/                     {pop cx       ;CX = Size}
  $5E/                     {pop si}
  $1F/                     {pop ds       ;DS:SI => V[1]}
  $89/$F7/                 {mov di,si    ;DS:DI = V[Size]}
  $01/$CF/                 {add di,cx}
  $4F/                     {dec di}
  $D1/$E9/                 {shr cx,1}
  {                         again:}
  $8A/$04/                 {mov al,[si]  ;switch DS:DI}
  $86/$05/                 {xchg al,[di] ; and DS:DI}
  $88/$04/                 {mov [si],al}
  $46/                     {inc si       ;adjust indexes}
  $4F/                     {dec di}
  $E2/$F6/                 {loop again}
  $8E/$DB);                {mov ds,bx    ;restore DS}

procedure ToggleBits(var V; Size : Word);        {!!.04}
  {-Toggle the bits from V[1] to V[Size]}        {!!.04}
 inline(
  $59/                     {pop cx  ;cx = Size}
  $5F/                     {pop di}
  $07/                     {pop es  ;es:di -> V}
                           {again:}
  $26/$F6/$15/             {not byte ptr es:[di] ;flip bits}
  $47/                     {inc di}
  $E2/$FA);                {loop again}


function SwapWord(L : LongInt) : LongInt;
  {-Swap low- and high-order words of L}
 inline(
  $5A/                     {pop dx ;pop low word into DX}
  $58);                    {pop ax ;pop high word into AX}

function IntToKey(I: integer) : integer;
  {-Convert an integer to a string}
 begin
  IntToKey:=Swap(I xor $8000);
 end;

function KeyToInt(I: integer) : Integer;
  {-Convert a string to an integer}
 begin
  KeyToInt:=Swap(I) xor $8000;
 end;

function LongToKey(L: LongInt) : longint;
  {-Convert a longint to a string}
 var Result: longint;
 begin
  L := L xor $80000000;
  LongRec(Result).Hi := Swap(LongRec(L).Lo);
  LongRec(Result).Lo := Swap(LongRec(L).Hi);
  LongToKey := Result;
 end;

function KeyToLong(L: longint) : LongInt;
  {-Convert a string to a longint}
 begin
  LongRec(L).Hi:=Swap(LongRec(L).Hi);
  LongRec(L).Lo:=Swap(LongRec(L).Lo);
  KeyToLong := SwapWord(L) xor $80000000;
 end;

function DoubToKey(D : Double) : Double;
  {-Convert an extended to a string}
 var
  Temp: double;
  Ex  : byte absolute Temp;
 begin
  Temp:=D;

  {move the exponent to the front and put mantissa in MSB->LSB order}
  ReverseBytes(Temp, 8);

  {flip the sign bit}
  Ex:=Ex xor $80;

  if Ex and $80 = 0 then
   begin
    ToggleBits(Temp, 8);
    Ex:=Ex and $7F;
   end;

  DoubToKey:=Temp;
 end;

function KeyToDoub(D : double) : double;
  {-Convert a string to an extended}
 var
  Temp: double;
  Ex  : byte absolute Temp;
 begin
  Temp:=D;
  {flip the sign bit}
  Ex:=Ex xor $80;

  if Ex and $80 <> 0 then
   begin
    ToggleBits(Temp, 8);
    Ex:=Ex or $80;
   end;

  {move the exponent back to the end and put mantissa in LSB->MSB order}
  ReverseBytes(Temp, 8);

  KeyToDoub:=Temp;
 end;

end.