{
 Dimarker's Software 1993
 Simple Paradox files BROWSER with cache;

  !  ப஢   ᪫⥫묨 
   ⠪   !
 ⮤ TRecCache.Compare, TBrowser.FldStr  TBrowser.GetText ஢७
 䠩஬ - ᫨ ,  ஢ ᠬ.
 㭪 GetRS 祭 ࠭,  ⠪   - ஬  祭
   祣 .
 TBrowser  樠樨  न, 㬥蠥 ࠢ  ᭨ 
 ,  ᮧ    ஫. ⮬   ⠢ 
 ,  ஥ ⠢ TBrowser.

  ⠩  ᪨-䨧᪨  .

}

unit PXBrowse;

interface uses Objects, OOPXENG, LList, Drivers, Dialogs, Views, PXOopMsg;

type
 PRecCache = ^TRecCache;
 TRecCache = object(TSortedCollection)
  ItemSize : word;
  constructor Init(ALimit, AItemSize: integer);
  function    Compare(Key1, Key2: pointer): integer; virtual;
  procedure   FreeItem(Item: pointer); virtual;
 end;

 ByteSet  = set of byte;

 PBrowser = ^TBrowser;
 TBrowser = object(TLongList)
  Cur     : PCursor;
  FldSet  : string;  { array of showed fields }
  FldTyp  : string;  { array of field's types }
  FldLen  : string;  { array of field's length }
  CurFld  : integer; { it's not a current field ! it is a pointer into FldSet}
  FldOfs  : ^WordArray;
  Cache   : PRecCache;
  Header  : PLabel;
  HScroll : PScrollBar; { special Horiz scrollbar. Don't use HScrollBar ! }
  EWin    : PDialog;
  constructor Init(var Bounds: TRect; PCur: PCursor; var FSet: ByteSet);
  function    GetRS: word; { get the recSize and FldOfs^ values }
  function    GetText(Item: longint; MaxLen: Integer): string; virtual;
  function    FldStr(FieldNo: integer; p: PByteArray): string;
  procedure   HandleEvent(var Event: TEvent); virtual;
  function    EditForm: PDialog;
  procedure   UpdateHeader;
  procedure   PutData(P: PDialog);
  procedure   TakeData(P: PDialog);
  destructor  Done; virtual;
  procedure   FocusItem(Item: longint); virtual;
 end;

 PBrowseWin = ^TBrowseWin;
 TBrowseWin = object(TDialog)
  Cur       : PCursor;
  V         : PBrowser;
  constructor Init(var Bounds: TRect; ATitle: TTitleStr; const TName: string);
  destructor  Done; virtual;
 end;

implementation uses KeyConv, Strings, PXENGINE, MsgBox, Fields, App, StdDlg,
                    Menus, DPGU, BGENC, BGENH;

const
 BlobData : record
  O       : word;
  E       : longint;
 end = (O:0; E:0);

type

 PBlobOpts = ^TBlobOpts;
 TBlobOpts = object(TDialog)
  O        : PCheckBoxes;
  E        : PLLongint;
  constructor Init;
 end;

 PImportOfs = ^TImportOfs;
 TImportOfs = object(TDialog)
  constructor Init;
 end;

 PRecItem = ^TRecItem;
 TRecItem = object(TObject)
  No    : longint;
  Rec   : PByteArray;
  constructor Init(N: longint; P: pointer);
 end;

 PLBlob = ^TLBlob;
 TLBlob = object(LString)
  Rc    : PRecord;
  Ft    : pxFieldSubType;
  constructor Init(var Bounds: TRect; ASize: byte; R: PRecord;N: pxFieldSubType);
  procedure HandleEvent(var Event: TEvent); virtual;
 end;

 PEditForm = ^TEditForm;
 TEditForm = object(TDialog)
  Sender   : PView;
  constructor Init(var Bounds: TRect; ATitle: TTitleStr; ASender: PView);
  procedure HandleEvent(var Event: TEvent); virtual;
 end;


const cmClear = 24; { as in Editors.PAS }

{ TEditForm }

constructor TEditForm.Init(var Bounds: TRect; ATitle: TTitleStr; ASender: PView);

 begin
  inherited Init(Bounds, ATitle);
  Sender:=ASender;
  HelpCtx:=hcBEditor;
 end;

procedure TEditForm.HandleEvent(var Event: TEvent);
 begin
  if Event.What = evKeyDown then
   case Event.KeyCode of
    kbUp  : Event.KeyCode:=kbShiftTab;
    kbDown: Event.KeyCode:=kbTab;
   end;
  if Event.What = evCommand then
   if Event.Command = cmOk then
    if Sender <> nil then
     begin
      Message(Sender, evCommand, cmSave, @Self);
      EndModal(cmOk);
      ClearEvent(Event);
     end;

  inherited HandleEvent(Event);
  if Event.What = evCommand then
   case Event.Command of
    cmRNext : begin
               ClearEvent(Event);
               if Sender <> nil then
                Message(Sender, evCommand, cmRNext, @Self);
              end;
    cmRPrev : begin
               ClearEvent(Event);
               if Sender <> nil then
                Message(Sender, evCommand, cmRPrev, @Self);
              end;
    cmSave  : begin
               ClearEvent(Event);
               if Sender <> nil then
                Message(Sender, evCommand, cmSave, @Self);
              end;
    cmClear : begin
              end;
   end;
 end;


{ TBlobOpts }

constructor TBlobOpts.Init;
 var
  B : PView;
  R : TRect;
 begin
  R.Assign(18, 7, 63, 15);
  inherited Init(R, 'BLOB options');
  Options:=Options or ofCentered;
  R.Assign(2, 2, 28, 4);
  O:=New(PCheckBoxes, Init(R,
      NewSItem('use ~p~rivate Blobs',
      NewSItem('~o~werwrite on import', nil))));
  Insert(O);
  R.Assign(15, 5, 28, 6);
  E:=New(PLLongint, Init(R));
  Insert(E);
  R.Assign(2, 5, 15, 6);
  Insert(New(PLabel, Init(R, 'Export ~f~rom', E)));

  R.Assign(30, 2, 42, 4);
  Insert(OkButton(R));
  R.Assign(30, 4, 42, 6);
  Insert(CancelButton(R));
  SelectNext(False);
 end;


{ TImportOfs }

constructor TImportOfs.Init;
 var
  B : PView;
  R : TRect;
 begin
  R.Assign(12, 8, 67, 15);
  inherited Init(R, 'Import offset');
  R.Assign(1, 1, 50, 2);
  Insert(New(PStaticText, Init(R, ^C'Blob is not empty, so you can specify offset to')));
  R.Assign(1, 2, 39, 3);
  Insert(New(PStaticText, Init(R, ^C'write your file into enxistant Blob.')));

  R.Assign(17, 4, 30, 5);
  B:=New(PLLongint, Init(R));
  Insert(B);
  R.Assign(2, 4, 17, 5);
  Insert(New(PLabel, Init(R, '~I~mport offset', B)));
  R.Assign(31, 4, 41, 6);
  Insert(OkButton(R));
  R.Assign(41, 4, 51, 6);
  Insert(CancelButton(R));
  SelectNext(False);
 end;


{ TLBlob }

constructor TLBlob.Init(var Bounds: TRect; ASize: byte; R: PRecord;N: pxFieldSubType);
 begin
  inherited Init(Bounds, ASize);
  EditSet:=[#0..#32];
  Rc:=R;
  Ft:=N;
  Idc:='B';
 end;

procedure TLBlob.HandleEvent(var Event: TEvent);
 var
  R: TRect;
  V: PMenuPopup;
  D: PDialog;
  S: TBufStream;
  Fn: string;
  blsz: longint;
  L: longint;
  B: PByteArray;
  rl: word;
  w: word;
 begin
  if ((Event.What = evKeyDown) and (Event.CharCode = #32)) or
     (((Event.What and evMouse) <> 0) and (Event.Buttons = mbRightButton)) then
   begin
   if Event.What = evKeyDown then
    MakeGlobal(Origin, R.A)
   else
    begin R.A:=Event.Where; Inc(R.A.X); end;
    ClearEvent(Event);
    if Ft <> fldstMemo then
     Application^.DisableCommands([cmEField]);
    New(V, Init(R, NewMenu(
     NewItem('E~d~it',    '', kbNoKey, cmEField,  hcNoContext,
     NewItem('~E~xport',  '', kbNoKey, cmYes, hcNoContext,
     NewItem('~I~mport',  '', kbNoKey, cmNo,  hcNoContext,
     NewItem('~O~ptions', '', kbNoKey, cmShift, hcNoContext,
    nil)))))));
    if R.A.Y+V^.Size.Y > DeskTop^.Size.Y then
     R.A.Y:=DeskTop^.Size.Y-V^.Size.Y;
    V^.Origin:=R.A;
    case DeskTop^.ExecView(V) of
     cmEField: begin
              Rc^.openBlobRead(Id, (BlobData.O and 1) <> 0);
              w:=cmCancel;
              L:=Rc^.getBlobSize(Id);
              Rc^.closeBlob(Id, False);
              if L > 64000 then
               begin
                MsgCancel('Blob is bigger than 65K. Use "Export" '+
                         'and external editor.');
               end
              else
               if MaxAvail > (L+512) then
                begin
{ PMemDialog - simply TDialog with inserted TMemo
                 R.Assign(1, 2, 50, 23);
                 D:=New(PMemDialog, Init(R, 'Memo', L+512));
                 D^.Options:=D^.Options or ofCentered;
                 Rc^.openBlobRead(Id, (BlobData.O and 1) <> 0);
                 rl:=2048; L:=0;
                 blsz:=Rc^.getBlobSize(Id);
                 GetMem(b, 2048);
                 if blsz-L < rl then rl:=blsz-L;
                 while L < blsz do
                  begin
                   if blsz-L < rl then rl:=blsz-L;
                   Rc^.getBlob(Id, rl, L, b);
                   PMemDialog(D)^.E^.InsertText(b, rl, False);
                   Inc(L, 2048);
                  end;
                 PMemDialog(D)^.E^.Modified:=False;
                 Rc^.closeBlob(Id, False);
                 if DeskTop^.ExecView(D) <> cmCancel then
                  begin

                  end;
                 Dispose(D, Done);}
                 { edit Blob with TMemo }
                end
               else
                begin
                 MsgCancel('Not enough memory to edit Blob.');
                end;
             end;
     cmYes : begin
              Rc^.openBlobRead(Id, (BlobData.O and 1) <> 0);
              if Rc^.lastError = pxSuccess then
              if Rc^.getBlobSize(Id) > 0 then
               begin
                D:=New(PFileDialog, Init('*.*', 'Export to', '~F~ile', fdOkButton, 101));
                w:=DeskTop^.ExecView(D);
                D^.getData(Fn);
                Dispose(D, Done);

                if w <> cmCancel then
                 begin
                  rl:=2048;
                  S.Init(Fn, stCreate, 2048);
                  blsz:=Rc^.getBlobSize(Id);
                  GetMem(b, 2048);
                  L:=BlobData.E;
                  if blsz-L < rl then rl:=blsz-L;
                  while L < blsz do
                   begin
                    if blsz-L < rl then rl:=blsz-L;
                    Rc^.getBlob(Id, rl, L, B);
                    S.Write(B^, rl);
                    Inc(L, 2048);
                   end;
                  S.Done;
                  FreeMem(b, 2048);
                 end;
               end;
              Rc^.closeBlob(Id, False);
             end;
     cmNo  : begin
              { heck to import to offset }
              Rc^.openBlobRead(Id, False);
              L:=Rc^.getBlobSize(Id);
              Rc^.closeBlob(Id, False);
              if (L > 0) and ((BlobData.O and 2) = 0) then
               begin
                D:=New(PImportOfs, Init);
                w:=Application^.ExecuteDialog(D, @L);
               end
              else L:=0;

              if w <> cmCancel then
               begin
                D:=New(PFileDialog, Init('*.*', 'Import from', '~F~ile', fdOpenButton, 101));
                w:=DeskTop^.ExecView(D);
                D^.GetData(Fn);
                Dispose(D, Done);
               end;

              if w <> cmCancel then
               begin
                rl:=2048;
                S.Init(Fn, stOpenRead, 2048);
                blsz:=S.getSize;

                Rc^.openBlobWrite(Id, L+blsz, (BlobData.O and 1) <> 0);

                GetMem(b, 2048);
                { don't set L ! }
                if blsz-L < rl then rl:=blsz-L;
                while L < blsz do
                 begin
                  if blsz-L < rl then rl:=blsz-L;
                  S.Read(b^, rl);
                  Rc^.putBlob(Id, rl, L, B);
                  Inc(L, 2048);
                 end;
                S.Done;
                FreeMem(b, 2048);
               end;
              Rc^.closeBlob(Id, True);
              Db.forceWrite;
             end;
     cmShift: begin
               D:=New(PBlobOpts, Init);
               Application^.ExecuteDialog(D, @BlobData);
              end;
    end;
    Application^.EnableCommands([cmEField]);
    ClearEvent(Event);
   end;
  if Event.What = evKeyDown then
   case Event.KeyCode of
    kbRight   :;
    kbLeft    :;
    kbTab     :;
    kbShiftTab:;
    kbEnd     :;
    kbHome    :;
    kbEsc     :;
    kbEnter   :;
   else ClearEvent(Event) end;
  inherited HandleEvent(Event);
 end;

{ TRecItem }

constructor TRecItem.Init(N: longint; P: pointer);
 begin
  TObject.Init;
  No:=N;
  Rec:=P;
 end;

constructor TRecCache.Init(ALimit, AItemSize: integer);
 begin
  inherited Init(ALimit, 0);
  Duplicates:=False;
  ItemSize:=AItemSize;
 end;

function  TRecCache.Compare(Key1, Key2: pointer): integer;
 { this procedure tested by Turbo Profler }
 begin
  if PRecItem(Key1)^.No > PRecItem(Key2)^.No then Compare:=1
  else if PRecItem(Key1)^.No < PRecItem(Key2)^.No then Compare:=-1
        else Compare:=0;
 end;

procedure TRecCache.FreeItem(Item: pointer);
 begin
  if Item <> nil then
   begin
    if PRecItem(Item)^.Rec <> nil then
     FreeMem(PRecItem(Item)^.Rec, ItemSize);
    Dispose(PRecItem(Item), Done);
   end;
 end;

constructor TBrowser.Init(var Bounds: TRect; PCur: PCursor; var FSet: ByteSet);
 var
  i: byte;
  S1, S2: pointer;
  R: TRect;
 begin
  if PCur = nil then begin Fail; Exit; end;
  R:=Bounds;
{  Dec(R.B.X); R.B.Y:=R.A.Y;
  Header:=New(PLabel, Init(R, '', ));
  Header^.GrowMode:=Header^.GrowMode or (gfGrowHiX);}

  R:=Bounds; Inc(R.A.Y); R.A.X:=R.B.X-1; Dec(R.B.Y);
  S1:=New(PScrollBar, Init(R));
  R.A.X:=Bounds.A.X; R.A.Y:=R.B.Y; Inc(R.B.Y);
  S2:=New(PScrollBar, Init(R));
  R:=Bounds; Inc(R.A.Y); Dec(R.B.Y); Dec(R.B.X);
  inherited Init(R, 1, nil, S1);
  HScroll:=S2;
  R:=Bounds; R.B.Y:=R.A.Y+1;
  Header:=New(PLabel, Init(R, '', @Self));
  GrowMode:=GrowMode or (gfGrowHiY or gfGrowHiX);
  Cur:=PCur;
  for i:=1 to 255 do
   if i in FSet then
    FldSet:=FldSet+char(i);
  if byte(FldSet[0]) > Cur^.genericRec^.getFieldCount then
   byte(FldSet[0]):=Cur^.genericRec^.getFieldCount;
  CurFld:=1;
  Cache:=New(PRecCache, Init(50, GetRS)); { GetRS is important call !!! }
  SetRange(Cur^.getRecCount);
  UpdateHeader;
 end;

function TBrowser.GetRS: word;
 var
  RS: word;
  i: integer;
  P: PFieldDesc;
  R: PRecord;
 begin
  GetRS:=0;
  if Cur = nil then Exit;
  R:=Cur^.genericRec;
  RS:=0;
  GetMem(FldOfs, (R^.getFieldCount) * SizeOf(Word));
  New(P, Init);
  for i:=1 to R^.getFieldCount do {      !}
   begin
    R^.getFieldDesc(i, P);
    if R^.lastError = PXSUCCESS then
     begin
      FldTyp:=FldTyp + char(P^.fldType);
      FldLen:=FldLen + char(P^.FldLen);
      FldOfs^[i]:=RS;
      case P^.fldType of
       fldBlob  : Inc(RS, P^.FldLen+10); { + 10 bytes for BLOB pointer }
       fldChar  : Inc(RS, P^.fldLen);
       fldDate  : Inc(RS, 4);
       fldDouble: Inc(RS, 8);
       fldShort : Inc(RS, 2);
      end;
     end;
   end;
  Dispose(P, Done);
  GetRS:=RS;
 end;

procedure TBrowser.FocusItem(Item: longint);
 var b: boolean;
 begin
  if Item <> Focused then b:=True else b:=False;
  inherited FocusItem(Item);
  if b then
   if EWin <> nil then
    begin
     Cur^.gotoRec(Focused+1);
     Cur^.getRecord(Cur^.genericRec);
     PutData(EWin);
    end;
 end;

function TBrowser.GetText(Item: longint; MaxLen: Integer): string;
 var
  P: PRecItem;
  i,e: integer;
  s: string; { ப - 㬥,  ᪮ }
  s1: string[15];
  n: byte;
  o: pointer;
 begin
  New(P, Init(Item, nil));
  { now we must find or get record }
  if not Cache^.Search(P, e) then
   begin
    GetMem(P^.Rec, Cache^.ItemSize);
    FillChar(p^.Rec^, Cache^.ItemSize, 0);
    Cur^.gotoRec(Item+1); { must be some error checking ... }
    Cur^.getRawRecord(P^.Rec, Cache^.ItemSize);
    for i:=1 to Cur^.genericRec^.getFieldCount do
     begin
      o:=@P^.Rec^[FldOfs^[i]];
      case PXFieldType(FldTyp[i]) of
       fldDouble: double(o^) :=KeyToDoub(double(o^));
       fldDate  : longint(o^):=KeyToLong(longint(o^));
       fldShort : integer(o^):=KeyToInt(integer(o^));
      end;
     end;
    if Cache^.Count = Cache^.Limit then { cache is full }
     begin
      if e > (Cache^.Count div 2) then { calculate most unused element }
       Cache^.AtFree(0)             { delete at list begining }
      else
       Cache^.AtFree(Cache^.Count-1); { delete at the list end }
     end;
    Cache^.Insert(P);
   end
  else
   begin
    Dispose(P, Done); { this is the one reason to dispose P }
    P:=Cache^.At(e);
   end;

  { now we must draw found record }
  Str((Item+1):5, s); s:=s+'';
  for i:=CurFld to byte(FldSet[0]) do
   begin
    if Length(s) > Size.X then Break;
    s:=s+FldStr(byte(FldSet[i]), P^.Rec)+'';
    { a real field number is passed via FldSet[i] ! }
   end;
  GetText:=s;
  { don't call Dispose for P !!! }
 end;

procedure TBrowser.UpdateHeader;
 var
  i: integer;
  s: string;
  s1: string;
  f: PFieldDesc;
 begin
  f:=New(PFieldDesc, Init);
  s:='     ';
  for i:=CurFld to byte(FldSet[0]) do
   begin
    if Length(s) > Size.X then Break;
    Cur^.genericRec^.getFieldDesc(byte(FldSet[i]), f);
    FillChar(s1, SizeOf(s1), #32);
    s1:=f^.fldName;
    case f^.fldType of
     fldChar,
     fldBlob : s1[0]:=char(f^.fldLen);
     fldDate : s1[0]:=#11;
     fldShort: s1[0]:=#6;
     flddouble:s1[0]:=#12;
    end;
    s:=s+s1+'';
   end;
  Dispose(f, Done);
  DisposeStr(Header^.Text);
  Header^.Text:=NewStr(Copy(s, 1, Header^.Size.X));
 end;

function TBrowser.FldStr(FieldNo: integer; p: PByteArray): string;
 var
  r: string;
  L: longint;
  DList: array [0..5] of integer;
  w: byte;
  o: pointer;
  s: longint;
 begin
  r[0]:=#0;
{  w:=byte(FldSet[FieldNo]); - wrong use }
  { a real field number must be passed via FieldNo !
    it can be made by using FldStr[i] in a outer call }
  o:=@P^[FldOfs^[FieldNo]];
  case PXFieldType(FldTyp[FieldNo]) of
   fldBlob  : begin
               byte(r[0]):=byte(FldLen[FieldNo]);
               if byte(r[0]) > 0 then
                Move(o^, r[1], byte(r[0]));
              end;
   fldChar  : begin
               byte(r[0]):=byte(FldLen[FieldNo]);
               FillChar(r[1], byte(r[0]), ' ');
               Move(o^, r[1], StrLen(PChar(O)));
              end;
   fldDouble: begin
               Str(double(o^):12:2, r);
              end;
   fldShort : begin
               Str(integer(o^):6, r);
              end;
   fldDate  : begin
               FillChar(DList, SizeOf(DList), 0);
               PXDateDecode(longint(o^), DList[2], DList[0], DList[4]);
               Dec(DList[4]);
               FormatStr(r, ' %02d/%02d/%4d', DList);
              end;
  end;
  FldStr:=r;
 end;

procedure TBrowser.HandleEvent(var Event: TEvent);
 var
  L: Longint;
  D: PDialog;
 begin
   if Event.What = evKeyDown then
    case Event.KeyCode of
     kbLeft  : if CurFld > 1 then
                begin
                 Dec(CurFld);
                 Owner^.Lock;
                 DrawView;
                 UpdateHeader;
                 HScroll^.SetValue(CurFld);
                 ClearEvent(Event);
                 Owner^.Unlock;
                 Owner^.Redraw;
                end;
     kbRight : if CurFld < byte(FldSet[0]) then
                begin
                 Inc(CurFld);
                 Owner^.Lock;
                 DrawView;
                 UpdateHeader;
                 HScroll^.SetValue(CurFld);
                 ClearEvent(Event);
                 Owner^.Unlock;
                 Owner^.Redraw;
                end;
    end;
  inherited HandleEvent(Event);
  if Event.What = evBroadcast then
   if (Event.Command = cmScrollBarChanged) and
      (Event.InfoPtr = pointer(HScroll)) then
    if CurFld <> HScroll^.Value then
     begin
      CurFld:=HScroll^.Value;
      Owner^.Lock;
      DrawView;
      UpdateHeader;
      ClearEvent(Event);
      Owner^.Unlock;
      Owner^.Redraw;
     end;
  if Event.What = evCommand then
   case Event.Command of
    cmRNext  : if Focused < Range-1 then
                begin
                 ClearEvent(Event);
                 FocusItem(Focused+1);
                end;
    cmRPrev  : if Focused > 0 then
                begin
                 ClearEvent(Event);
                 FocusItem(Focused-1);
                end;
    cmSave   : if EWin <> nil then
                begin
                 TakeData(EWin);
                 if CommandEnabled(cmRNext) then
                  Cur^.UpdateRec(Cur^.genericRec)
                 else
                  Cur^.appendRec(Cur^.genericRec);
                 if Cur^.lastError <> pxSUCCESS then
                  MessageBox(^C+PXOopErrMsg(Cur^.lastError), nil,
                             mfError+mfCancelButton)
                 else
                  begin
                   SetRange(Cur^.getRecCount);
                   Cache^.FreeAll;
                   DrawView;
                  end;
                end;
    cmInsRec : if EWin = nil then
                begin
                 EWin:=EditForm;
                 DisposeStr(EWin^.Title);
                 EWin^.Title:=NewStr('Insert form');
                 Application^.DisableCommands([cmRNext, cmRPrev]);
                 DeskTop^.ExecView(EWin);
                 Dispose(EWin, Done);
                 Application^.EnableCommands([cmRNext, cmRPrev]);
                 EWin:=Nil;
                end;
    cmDelRec : begin
                if Range > 0 then
                 begin
                  if Cur^.gotoRec(Focused+1) = PXSUCCESS then
                   begin
                    L:=Focused+1;
                    if MessageBox(^C'Delete record %d ?',@L,
                       mfWarning+mfOkButton+mfCancelButton) <> cmCancel then
                     begin
                      if Cur^.deleteRec <> PXSUCCESS then
                       MessageBox(^C+PXOopErrMsg(Cur^.lastError), nil,
                                  mfError+mfCancelButton)
                      else
                       begin
                        Cache^.FreeAll;
                        SetRange(Cur^.getRecCount);
                        Cache^.FreeAll;
                        DrawView;
                       end;
                     end;
                   end;
                 end;
               end;
    cmEditRec: if Range > 0 then
                begin
                 Cur^.gotoRec(Focused+1);
                 Cur^.getRecord(Cur^.genericRec);
                 EWin:=EditForm;
                 PutData(EWin);
                 DeskTop^.ExecView(EWin);
                 Dispose(EWin, Done);
                 EWin:=Nil;
                end;
   end;
 end;

procedure TBrowser.PutData(P: PDialog);
 procedure FindField(V: PLString); far;
  var
   buf: string;
   n: boolean;
   a: integer;
   rec: PRecord;
  begin
   if TypeOf(V^) <> TypeOf(TFrame) then
    if (V^.Id < 256) and (V^.Idc in ['S','D','T','G','I','U','B']) then
    begin
     rec:=Cur^.genericRec;
     if V^.Idc <> 'B' then
      rec^.getField(V^.Id, @buf, V^.DataSize, n)
     else
      begin
       rec^.openBlobRead(V^.Id, False);
       if rec^.getBlobSize(V^.Id) > 0 then
        begin
         rec^.getBlobHeader(V^.Id, V^.DataSize, @buf[1], a);
         buf[0]:=char(a);
        end
       else
        buf:='';
       rec^.closeBlob(V^.Id, False);
      end;
     if Cur^.genericRec^.lastError = pxSuccess then
      V^.SetData(buf);
    end;
  end;
 begin
  if p = nil then Exit;
  P^.Lock;
  P^.ForEach(@FindField);
  P^.Unlock;
  P^.ReDraw;
 end;

procedure TBrowser.TakeData(P: PDialog);
 procedure FindField(V: PLString); far;
  var
   buf: string;
   rec: PRecord;
  begin
   if TypeOf(V^) <> TypeOf(TFrame) then
    if (V^.Id < 256) and (V^.Idc in ['S','D','T','G','I','U']) then
    begin
     rec:=Cur^.genericRec;
     V^.getData(buf);
     rec^.putField(V^.Id, @buf, V^.DataSize);
    end;
  end;
 begin
  if P = nil then Exit;
  P^.ForEach(@FindField);
 end;

function TBrowser.EditForm: PDialog;
 var
  D: PDialog;
  b,c: byte;
  i: integer;
  p: PFieldDesc;
  R: TRect;
  L: PLabel;
  V: PView;
 begin
  b:=0; c:=20;
  p:=New(PFieldDesc, Init);
  for i:=0 to Cur^.genericRec^.getFieldCount-1 do
   begin
    Cur^.genericRec^.getFieldDesc(i+1, p);
    if Length(p^.fldName) > b then b:=Length(p^.fldName)+1;
    if p^.fldLen > c then c:=p^.fldLen;
   end;

  R.Assign(0, 0, 78, Cur^.genericRec^.getFieldCount+4);
  R.B.X:=2+b+2+c+2; if R.B.X > 78 then R.B.X:=78;

  D:=New(PEditForm, Init(R, 'Edit Record', @Self));
  D^.Options:=D^.Options or ofCentered;

  R.A.X:=0; R.A.Y:=1;
  for i:=0 to Cur^.genericRec^.getFieldCount-1 do
   begin
    Cur^.genericRec^.getFieldDesc(i+1, p);
    R.A.Y:=R.A.Y+1; R.B.Y:=R.A.Y+1; {  /⪨  ⨪ }

    R.A.X:=2+b; R.B.X:=D^.Size.X-2;
    case p^.fldType of
     fldDouble : V:=New(PLDouble,  Init(R, 15, 2));
     fldDate   : case p^.fldSubType of
                  fldstNone : V:=New(PLDate,    Init(R, 'dd/mm/yyyy'));
                  fldstLong : V:=New(PLLongint, Init(R));
                  fldstTime : V:=New(PLTime,    Init(R, 'hh:mm:ss'));
                 end;
     fldShort  : V:=New(PLInteger, Init(R));
     fldChar   : begin
                  if R.B.X-R.A.X-2 > p^.fldLen+1 then
                   R.B.X:=R.A.X+3 + p^.fldLen;
                  V:=New(PLString,  Init(R, p^.fldLen+1));
                 end;
     fldBlob   : begin
                  if R.B.X-R.A.X-2 > p^.fldLen then
                   R.B.X:=R.A.X+2 + p^.FldLen;
                  V:=New(PLBlob,    Init(R, p^.fldLen, Cur^.genericRec, p^.fldSubType));
                 end
    end;
  if V <> nil then PLString(V)^.Id:=i+1;
    D^.Insert(V);

    R.A.X:=1; R.B.X:=b+1; { /ࠢ ࠩ ⪨ }
    L:=New(PLabel, Init(R, p^.fldName, V));
    D^.Insert(L);
   end;

  Dispose(P, Done);
  D^.SelectNext(False);
  EditForm:=D;
 end;

destructor  TBrowser.Done;
 begin
  if FldOfs <> nil then FreeMem(FldOfs, (Cur^.genericRec^.getFieldCount) * SizeOf(word));
  if Cache <> nil then Dispose(Cache, Done);
  inherited Done;
 end;

constructor TBrowseWin.Init(var Bounds: TRect; ATitle: TTitleStr; const TName: string);
 var s: ByteSet;
 begin
  inherited Init(Bounds, ATitle);
  Flags:=Flags or wfGrow;
  Cur:=New(PCursor, InitAndOpen(@DB, TName, 0, False));
  if Cur = nil then
   begin
    Done;
    Fail;
   end;
  GetExtent(Bounds);
  Bounds.Grow(-1,-1);
  s:=[1..255]; { 뢠 ,  ᯮ ⠪.}
  V:=New(PBrowser, Init(Bounds, Cur, s));
  Insert(V);
  Insert(V^.HScroll);
  Insert(V^.VScrollBar);
  Insert(V^.Header);
  V^.HScroll^.SetParams(1, 1, Cur^.genericRec^.getFieldCount, 1, 1);
  HelpCtx:=hcBrowser;
 end;

destructor TBrowseWin.Done;
 begin
  inherited Done; { must be FIRST ! because Cur is used in TBrowser.Done }
  if Cur <> nil then Dispose(Cur, Done);
 end;

end.
